import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class MultithreadedSocketServer {
    private static final int SERVER_PORT = 8888;

    public static void main(String[] args) {
        ServerSocket socket = null;
        int clientsCount = 0;

        try {
            socket = new ServerSocket(SERVER_PORT);
            System.out.println("Server started!");

            while (true) {
                Socket clientSocket = socket.accept();
                System.out.println("Client connected from "
                        + clientSocket
                            .getInetAddress()
                            .getHostAddress());

                new Thread(
                        new ClientHandler(
                                clientSocket, clientsCount++)
                ).start();
            }
        } catch (IOException ioe) {
            System.out.println(ioe.getMessage());
        } finally {
            try {
                socket.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
